(function() {
  var Potato, Tuber, apply_mixins, delegateTo, extend, recursiveExtend;
  var __slice = Array.prototype.slice;
  extend = function(dest, extra) {
    var k, v;
    for (k in extra) {
      v = extra[k];
      dest[k] = v;
    }
    return dest;
  };
  recursiveExtend = function(dest, extra) {
    var k, v;
    for (k in extra) {
      v = extra[k];
      if ((typeof v) === "object") {
        if (!(dest[k] != null)) {
          dest[k] = {};
        }
        recursiveExtend(dest[k], v);
      } else {
        dest[k] = v;
      }
    }
    return dest;
  };
  Tuber = function(content) {
    var extendMyself, k, v, _fn, _ref;
    if (!(content.static != null)) {
      content.static = {};
    }
    _ref = content.methods;
    _fn = function(k, v) {
      if (!(content.static[k] != null)) {
        return content.static[k] = function() {
          var args, self, _ref2;
          self = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
          return (_ref2 = content.methods[k]).call.apply(_ref2, [self].concat(__slice.call(args)));
        };
      }
    };
    for (k in _ref) {
      v = _ref[k];
      _fn(k, v);
    }
    extendMyself = function(extraContent) {
      var msg, new_content;
      if (this.constructor.THIS_IS_NOT_A_CONSTRUCTOR_DUMMY != null) {
        msg = "Do no call 'new YourPotato()'. Instanciation is done via YourPotato.make()'.";
        throw msg;
      }
      new_content = recursiveExtend({}, content);
      recursiveExtend(new_content, extraContent);
      return Tuber(new_content);
    };
    extendMyself.THIS_IS_NOT_A_CONSTRUCTOR_DUMMY = true;
    recursiveExtend(extendMyself, content.static);
    extendMyself.__content = content;
    return extendMyself;
  };
  Tuber.__content = {};
  delegateTo = function(delegateMember, methodName) {
    return function() {
      var member;
      member = delegateMember.apply(this);
      return member[methodName].apply(member, arguments);
    };
  };
  Potato = Tuber({
    methods: {
      components: function() {
        return this.__potato__.components(this);
      },
      set: function(data) {
        var component, components, k, v;
        components = this.components();
        for (k in data) {
          v = data[k];
          component = components[k];
          if (component != null) {
            this[k] = component.set(this[k], v);
          } else {
            Potato.error(k + " is not a member of this potato.");
          }
        }
        return this;
      },
      toJSON: function() {
        return JSON.stringify(this.toData());
      },
      toData: function() {
        var data, k, v, _ref;
        data = {};
        _ref = this.components();
        for (k in _ref) {
          v = _ref[k];
          data[k] = v.toData(this[k]);
        }
        return data;
      }
    },
    static: {
      __init__: function(obj) {},
      make: function(data) {
        var actualConstructor, delegateMember, methodName, newInstance, potato, _ref;
        if (data == null) {
          data = {};
        }
        potato = this;
        actualConstructor = function(data) {
          var k, v, _ref;
          if (data == null) {
            data = {};
          }
          _ref = potato.__content.components;
          for (k in _ref) {
            v = _ref[k];
            this[k] = v.make();
          }
          return this;
        };
        actualConstructor.prototype.__potato__ = potato;
        extend(actualConstructor.prototype, potato.__content.methods);
        _ref = potato.__content.delegate;
        for (methodName in _ref) {
          delegateMember = _ref[methodName];
          actualConstructor.prototype[methodName] = delegateTo(delegateMember, methodName);
        }
        newInstance = new actualConstructor;
        newInstance.set(data);
        this.__init__(newInstance);
        return newInstance;
      },
      fromJSON: function(json) {
        var data;
        data = JSON.parse(json);
        return this.fromData(data);
      },
      fromData: function(data) {
        return this.make(data);
      },
      components: function() {
        return this.__content.components;
      }
    }
  });
  Potato.error = function() {
    var arg, args, _i, _len, _results;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    _results = [];
    for (_i = 0, _len = args.length; _i < _len; _i++) {
      arg = args[_i];
      _results.push(console.log("ERROR : ", arg));
    }
    return _results;
  };
  Potato.Skin = Potato({
    static: {
      set: function(obj, data) {
        obj.data = data;
        return obj;
      },
      toData: function(obj) {
        return obj.data;
      }
    }
  });
  Potato.Litteral = Tuber({
    static: {
      make: function(val) {
        if (val != null) {
          return val;
        } else {
          return this.__content["default"];
        }
      },
      toJSON: function(val) {
        return JSON.stringify(this.toData(val));
      },
      toData: function(val) {
        return val;
      },
      set: function(obj, val) {
        return val;
      }
    }
  });
  Potato.List = Potato({
    methods: {
      push: function(item) {
        return this.items.push(item);
      },
      get: function(i) {
        return this.items[i];
      },
      toData: function() {
        var it, _i, _len, _ref, _results;
        _ref = this.items;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          it = _ref[_i];
          _results.push(this.__potato__.itemType.toData(it));
        }
        return _results;
      },
      set: function(itemsData) {
        var itemData;
        this.items = (function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = itemsData.length; _i < _len; _i++) {
            itemData = itemsData[_i];
            _results.push(this.__potato__.itemType.make(itemData));
          }
          return _results;
        }).call(this);
        return this;
      }
    },
    static: {
      itemType: Potato.Litteral({
        "default": null
      }),
      make: function(data) {
        var actualConstructor, newInstance, potato;
        if (data == null) {
          data = [];
        }
        potato = this;
        actualConstructor = function() {
          this.items = [];
          return this;
        };
        actualConstructor.prototype.__potato__ = potato;
        extend(actualConstructor.prototype, potato.__content.methods);
        newInstance = new actualConstructor();
        newInstance.set(data);
        return newInstance;
      }
    }
  });
  Potato.ListOf = function(itemType) {
    return Potato.List({
      static: {
        itemType: itemType
      }
    });
  };
  Potato.Map = Potato({
    methods: {
      push: function(key, value) {
        return this.map[key] = value;
      },
      get: function(key) {
        return this.map[key];
      },
      toData: function() {
        var data, k, v, _ref;
        data = {};
        _ref = this.map;
        for (k in _ref) {
          v = _ref[k];
          data[k] = this.__potato__.itemType.toData(v);
        }
        return data;
      },
      set: function(data) {
        var k, v;
        this.map = {};
        for (k in data) {
          v = data[k];
          this.push(k, this.__potato__.itemType.make(v));
        }
        return this;
      }
    },
    static: {
      itemType: Potato.Litteral({
        "default": null
      }),
      make: function(data) {
        var actualConstructor, newInstance, potato;
        if (data == null) {
          data = {};
        }
        potato = this;
        actualConstructor = function() {
          this.map = {};
          return this;
        };
        actualConstructor.prototype.__potato__ = potato;
        extend(actualConstructor.prototype, potato.__content.methods);
        newInstance = new actualConstructor();
        newInstance.set(data);
        return newInstance;
      }
    }
  });
  Potato.MapOf = function(itemType) {
    return Potato.Map({
      static: {
        itemType: itemType
      }
    });
  };
  Potato.runTests = function(TESTS) {
    var testId, _ref, _results;
    _results = [];
    for (testId = 0, _ref = TESTS.length; 0 <= _ref ? testId < _ref : testId > _ref; 0 <= _ref ? testId++ : testId--) {
      _results.push((function() {
        try {
          TESTS[testId]();
          return console.log('[  OK  ]', '   Test', testId + 1);
        } catch (e) {
          console.log(e);
          return console.log('[ FAIL ]', '   Test', testId + 1);
        }
      })());
    }
    return _results;
  };
  apply_mixins = function(potato, mixins) {
    var mixin, _i, _len;
    for (_i = 0, _len = mixins.length; _i < _len; _i++) {
      mixin = mixins[_i];
      potato = potato(mixin);
    }
    return potato;
  };
  Potato.mixin = function() {
    var PotatoWithMixins, k, mixins, v;
    mixins = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    PotatoWithMixins = apply_mixins(this, mixins);
    for (k in this) {
      v = this[k];
      if ((v.__content != null) && k !== "Mixin") {
        PotatoWithMixins[k] = apply_mixins(this[k], mixins);
      }
    }
    return PotatoWithMixins;
  };
  Potato.Mixin = function(x) {
    return x;
  };
  Potato.notImplemented = function() {
    throw "Not Implemented Error";
  };
  if (typeof window !== "undefined" && window !== null) {
    window.Potato = Potato;
  } else {
    module.exports = Potato;
  }
}).call(this);
